#include <JGL/JGL.h>

void JGL::ShapeCache::Init() {
    if (!cube_vertex_data) {
        std::array<Vector3, 24> vertices {
                Vector3(-1, 1, -1), Vector3(1, 1, -1),
                Vector3(1, 1, -1), Vector3(1, 1, 1),
                Vector3(1, 1, 1), Vector3(-1, 1, 1),
                Vector3(-1, 1, 1), Vector3(-1, 1, -1),
                Vector3(-1, -1, -1), Vector3(1, -1, -1),
                Vector3(1, -1, -1), Vector3(1, -1, 1),
                Vector3(1, -1, 1), Vector3(-1, -1, 1),
                Vector3(-1, -1, 1), Vector3(-1, -1, -1),
                Vector3(-1, -1, -1), Vector3(-1, 1, -1),
                Vector3(1, -1, -1), Vector3(1, 1, -1),
                Vector3(1, -1, 1), Vector3(1, 1, 1),
                Vector3(-1, -1, 1), Vector3(-1, 1, 1)
        };
        cube_vertex_data = new VRamList(vertices.data(), vertices.size());
    }

    if (!cube_index_data) {
        std::array<GLuint, 36> indices {
                0, 1, 3, 0, 3, 5,

                8, 9, 11, 8, 11, 13,

                5, 3, 11, 5, 11, 13,

                0, 1, 9, 0, 9, 8,

                0, 5, 13, 0, 13, 8,

                1, 3, 11, 1, 11, 9
        };
        cube_index_data = new VRamList(indices.data(), indices.size());
    }

    if (!j2d_default_normal_data) {
        std::array<GLfloat, 3> normal {0, 0, 1};
        j2d_default_normal_data = new VRamList(normal.data(), normal.size());
    }
}